
-- # import Setoid
-- # import Order

sig Poset : Type extends Setoid where
  leq : PartialOrder (mkSetoid (mkSET el) eq)
  lt  : StrictPartialOrder (mkSetoid (mkSET el) eq)

mkPoset : (A:Setoid) -> PartialOrder A -> StrictPartialOrder A -> Poset
mkPoset A leq lt = struct el  = El A
			  eq  = A.eq
			  leq = leq
			  lt  = lt

(<=) (A:Poset) : El A -> El A -> PROP
(<=) {A} = A.leq.rel

(<) (A:Poset) : El A -> El A -> PROP
(<) {A} = A.lt.rel

sig TotallyOrderedSet : Type extends Setoid where
  leq : TotalOrder (mkSetoid (mkSET el) eq)
  lt  : StrictTotalOrder (mkSetoid (mkSET el) eq)

TotalPoset : TotallyOrderedSet -> Poset
TotalPoset A =
  struct el  = A.el
	 eq  = A.eq
	 leq = A.leq
	 lt  = A.lt

